C
C****************************************************************************
C                                                                           *
C         Date: 11/09/97                                                    *
C         author: A. Gasparian                                              *
C                                                                           *
C                                                                           *
C  6/26/98 D. Lawrence Modified                                             *
C  3/14/00 D. Lawrence positioning of calorimeter elements for pi0          *
C...........................................................................*.
C.
      SUBROUTINE CALORIMETER_ETA
C
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/NEWDET/PI0DET(4),LGWIDTH,LGLENGTH,INWIDTH,INLENGTH,WRAP
     +      ,AIRGAP,GEOMTYPE
      COMMON/THARGT/THRPOS(3)
C
      DIMENSION PAR( 8)

      REAL PI0DET,LGWIDTH,LGLENGTH,INWIDTH,INLENGTH,WRAP,AIRGAP
      REAL PAR

C********************************************************
C           Define the vacuum beam pipe
C*******************************************************
C  Vacuum Beam pipe
      PAR(1) = 0.0
      PAR(2) = 4.0
      PAR(3) = (PI0DET(3)-(THRPOS(3)+50.0))/2.0

      ZSOP = (PI0DET(3)+(THRPOS(3)+50.0))/2.0
      CALL GSVOLU( 'VPIP' , 'TUBE' , 7, PAR , 3 , IVOL )
      CALL GSPOS( 'VPIP' ,6000, 'HALB' ,0.0, 0.0, ZSOP, 0,'MANY')
C

C********************************************************
C           Define the virtual absorber wall
C*******************************************************
C  Beam hole for the VABW
      PAR(1) = LGWIDTH*3.0/2.0
      PAR(2) = PAR(1)
      PAR(3) = 25.0

      CALL GSVOLU( 'VABH' , 'BOX ' , 4, PAR , 3 , IVOL )
      PAR(1) = LGWIDTH*35.0/2.0
      PAR(2) = PAR(1)
C
      CALL GSVOLU( 'VABW' , 'BOX ' , 22, PAR , 3 , IVOL )
      ZSOP = PI0DET(3)+(LGLENGTH+AIRGAP+WRAP)+PAR(3)
      CALL GSPOS( 'VABH' ,3000, 'VABW' ,0.0, 0.0, 0.0, 0,'ONLY')
      CALL GSPOS( 'VABW' ,2040, 'HALB' ,0.0, 0.0, ZSOP, 0,'MANY')
      CALL GSDETV('WALL','VABW',3000,100,100,ISET,IDET)
C


C.
C     
C                    POSITIONING OF THE DETECTORS 'TTSW' INSIDE OF 'HALB'
C             with shape as 25x25 matrises
C                         ---- ---- ----
C                        |  1 |  2 |  3 |    ...  27
C                         ---- ---- ----
C                        | 28 | 29 | 30 |
C                         ---- ---- ----
C                        | 55 | 56 | 57 |
C                         ---- ---- ----
C                         .
C                         .
C                         703                    729
C
C                                        view: as seen by the beam
C
C  Note:
C       Even though lead-glass detectors aren't placed in the
C       center (where the insertion goes) the numbering system
C       counts those spots so the detector number will be easy
C       to correlate with the position in the array. Hence, the
C       last lead-glass detector is #625 even though there are
C       only 504 lead-glass detectors.
C
C**********************************************************
C                Position Lead GLass Array
C**********************************************************
C
C
      FULLWIDTH=LGWIDTH+(2.0*AIRGAP)+(2.0*WRAP)
C
		IF (GEOMTYPE.eq.2) THEN
			XLIM=0
		ELSE
			XLIM=18
		ENDIF
C
      DO 483 I=1,35
         DO 484 J=1,35
C
           XSOP = (18.0-I)*FULLWIDTH 
           YSOP = (18.0-J)*FULLWIDTH
           ZSOP = PI0DET(3)+(LGLENGTH/2.0)
C
           NRCOPY = 35*(J-1)+I
C
           IF(J.gt.18.or.J.lt.18.or.I.gt.18.or.I.lt.XLIM) THEN
           CALL GSPOS( 'TTSW' ,NRCOPY, 'HALB' ,XSOP,YSOP,ZSOP, 0,'ONLY')
           ENDIF
C
 484     CONTINUE
 483  CONTINUE
C
      CALL GSDETV('OUTR','TTSW',1,100,100,ISET,IDET)
C
      RETURN
      END
C
C










