C
C****************************************************************************
C                                                                           *
C         Date: 11/09/97                                                    *
C         author: A. Gasparian                                              *
C                                                                           *
C                                                                           *
C  6/26/98 D. Lawrence Modified                                             *
C  3/14/00 D. Lawrence positioning of calorimeter elements for pi0          *
C...........................................................................*.
C.
      SUBROUTINE CALORIMETER_PI
C
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/NEWDET/PI0DET(4),LGWIDTH,LGLENGTH,INWIDTH,INLENGTH,WRAP
     +      ,AIRGAP
C
      DIMENSION PAR( 8)

      REAL PI0DET,LGWIDTH,LGLENGTH,INWIDTH,INLENGTH,WRAP,AIRGAP
      REAL PAR


C********************************************************
C           Define the virtual absorber wall
C*******************************************************
C  Beam hole for the VABW
      PAR(1) = 4.0
      PAR(2) = PAR(1)
      PAR(3) = 25.0

      CALL GSVOLU( 'VABH' , 'BOX ' , 4, PAR , 3 , IVOL )
      PAR(1) = 55.0
      PAR(2) = PAR(1)
C
      CALL GSVOLU( 'VABW' , 'BOX ' , 22, PAR , 3 , IVOL )
      ZSOP = PI0DET(3)+(LGLENGTH+AIRGAP+WRAP)+PAR(3)
      CALL GSPOS( 'VABH' ,3000, 'VABW' ,0.0, 0.0, 0.0, 0,'ONLY')
      CALL GSPOS( 'VABW' ,2040, 'HALB' ,0.0, 0.0, ZSOP, 0,'MANY')
      CALL GSDETV('WALL','VABW',3000,100,100,ISET,IDET)
C


C.
C     
C                    POSITIONING OF THE DETECTORS 'TTSW' INSIDE OF 'HALB'
C             with shape as 25x25 matrises
C                         ---- ---- ----
C                        |  1 |  2 |  3 |    ...  27
C                         ---- ---- ----
C                        | 28 | 29 | 30 |
C                         ---- ---- ----
C                        | 55 | 56 | 57 |
C                         ---- ---- ----
C                         .
C                         .
C                         703                    729
C
C                                        view: as seen by the beam
C
C  Note:
C       Even though lead-glass detectors aren't placed in the
C       center (where the insertion goes) the numbering system
C       counts those spots so the detector number will be easy
C       to correlate with the position in the array. Hence, the
C       last lead-glass detector is #625 even though there are
C       only 504 lead-glass detectors.
C
C**********************************************************
C                Position Lead GLass Array
C**********************************************************
C
C
      FULLWIDTH=LGWIDTH+(2.0*AIRGAP)+(2.0*WRAP)
C
C
      DO 483 I=1,27
         DO 484 J=1,27
C
           XSOP = (14.0-I)*FULLWIDTH 
           YSOP = (14.0-J)*FULLWIDTH
           ZSOP = PI0DET(3)+(LGLENGTH/2.0)
C
           NRCOPY = 27*(J-1)+I
C
           IF(I.LE.8.or.I.GT.19.or.J.LE.8.or.J.GT.19) THEN
           CALL GSPOS( 'TTSW' ,NRCOPY, 'HALB' ,XSOP,YSOP,ZSOP, 0,'ONLY')
           ENDIF
C
 484     CONTINUE
 483  CONTINUE
C
      CALL GSDETV('OUTR','TTSW',1,100,100,ISET,IDET)
C
C**********************************************************
C                Position Insertion Array
C**********************************************************
C
C
      FULLWIDTH=FULLWIDTH/2.0
C
C
      DO 485 I=1,22
      DO 486 J=1,22     
      
           XSOP = (11.5-I)*FULLWIDTH 
           YSOP = (11.5-J)*FULLWIDTH
           ZSOP = PI0DET(3)+(LGLENGTH/2.0)-((LGLENGTH-INLENGTH)/2.0)
C
           NRCOPY = 22*(J-1)+I+1000
C
           IF(I.LE.10.or.I.GE.13.or.J.LE.10.or.J.GE.13) THEN
           CALL GSPOS( 'TTIN' ,NRCOPY, 'HALB' ,XSOP,YSOP,ZSOP, 0,'ONLY')
           ENDIF
C
 486     CONTINUE
 485  CONTINUE
C
      CALL GSDETV('INNR','TTIN',2,100,100,ISET,IDET)
C
      RETURN
      END
C
C










