

#include "psim.h"

/* Why do I have to do this ??!! */
#ifdef linux
void calorimeter_pi_(void){calorimeter_pi__();}
void calorimeter_eta_(void){calorimeter_eta__();}
void dipole_eta_(void){dipole_eta__();}
#endif

void ugeom(void)
{
   int NRCOPY;
   
   /* Check geometry type */
   if(GEOMETRY_TYPE!=0 && GEOMETRY_TYPE!=1 && GEOMETRY_TYPE!=2){
      printf("Unknown GEOMETRY_TYPE (%d)\n",GEOMETRY_TYPE);
      exit(-1);
   }

   /* Define Materials */
   gumat_();
   
   /* Define tracking Media */
   gutmed_();
   
   /* Define rotation matrices */
   rotmat_();
   
   /* Define mother volume */
   if(flags[verbose])printf("\tDefining Mother Volume...\n");fflush(stdout);
   mother_();
   
   /* Define target */    
   if(flags[verbose])printf("\t\tdefining target...\n");fflush(stdout);
   if(GEOMETRY_TYPE==0)
      target_();
   else if(GEOMETRY_TYPE==1 || GEOMETRY_TYPE==2)
      recoil_();
   
   /* Define magnet */
   if(flags[verbose])printf("\t\tdefining dipole...\n");fflush(stdout);
   if(GEOMETRY_TYPE==0)
      dipole_();
   else if(GEOMETRY_TYPE==2)
      dipole_eta_();

   /* Define calorimeter */
   if(flags[verbose])printf("\t\tdefining calorimeter...\n");fflush(stdout);
   calorimeter_();
   if(GEOMETRY_TYPE==0)
      calorimeter_pi_();
   else if(GEOMETRY_TYPE==1 || GEOMETRY_TYPE==2)
      calorimeter_eta_();
   
   /* Define pair counters */
   if(flags[verbose])printf("\t\tdefining paircounters...\n");fflush(stdout);
   if(GEOMETRY_TYPE==0)
      paircntr_();
   else if(GEOMETRY_TYPE==1 || GEOMETRY_TYPE==2);
      
  


   printf("=====================================================\n");
   printf("=====================================================\n");
   printf("             Finished defining geometry !!!          \n");
   printf("=====================================================\n");
   printf("=====================================================\n");
}



