


extern "C" {
   #include <psim.h>

   void vetocntr_(void);
}

//======================================================
// Here are defined the charged particle veto counters.
//=======================================================

// These are all in cm.

// These are all in degrees



void vetocntr_(void)
{
   float PAR[3];
   int IVOL,ISET,IDET;
   float widths[] ={ 14.0 , 14.0 , 12.0 ,  9.0 ,  9.0 ,  9.0 ,  9.0 , 12.0 , 14.0 , 14.0 };
   char names[][8]={"VET3","VET3","VET2","VET1","VET1","VET1","VET1","VET2","VET3","VET3"};
   int i,base;
   float x,y,z;

	// All counters will be 5mm thick and 116 cm tall (see note below)
	PAR[1]=116.0/2.0;
	PAR[2]=  0.5/2.0;
	

	// Original design calls for veto counters 8,8,10,12,12 cm wide to cover
	// 100 cm of calorimeter area. The calorimeter design changed slightly
	// so that the total width is now (4.25cm * 27)=114.75cm
	// To accomodate the new design veto counters of widths 9,9,12,14,14 cm 
	// will be used which will cover a width of 116cm
   PAR[0]= 9.0/2.0;
   gsvolu("VET1","BOX ", 5 ,PAR,3,&IVOL);
   PAR[0]=12.0/2.0;
   gsvolu("VET2","BOX ", 5 ,PAR,3,&IVOL);
   PAR[0]=14.0/2.0;
   gsvolu("VET3","BOX ", 5 ,PAR,3,&IVOL);

   // position detectors
   y=0.0;
   base=800;
   z=newdet_.pi0d[2]-1.0; // center veto counters at 1.0cm upstream from calorimeter
	x=0.0;
	for(i=0;i<5;i++)x-=widths[i];
	for(i=0;i<10;i++){
		gspos(names[i] ,base+i, "HALB" ,x+widths[i]/2.0,y,z, 0,"MANY");
		x+=widths[i];
	}
   
   
   // Add VETO counters to detector set VETO
   gsdetv("VETO","VET1",base,100,100,&ISET,&IDET);
   gsdetv("VETO","VET2",base,100,100,&ISET,&IDET);
   gsdetv("VETO","VET3",base,100,100,&ISET,&IDET);


   // Create beam hole
	PAR[0]=0.0;
	PAR[1]=newdet_.lgwidth/2.0;
	gsvolu("VHOL","TUBE", 1 ,PAR,3,&IVOL);
	gspos("VHOL",5000, "HALB" ,0.0,0.0,z, 0,"ONLY");
   

}




