


#include "psim.h"


void find_theta_phi(vect4 v, float *theta,float *phi_ret);

extern float max_energy;

int NTPULE_EVENTS_WRITTEN=0;

void fill_histos(void* RE)
{
   int i,j,something_hit=0;
   subset *s;
   raw_event_t *re=(raw_event_t*)RE;
   float *SHWDET  = re->SHWDET;
   float *TSHWDET = re->TSHWDET;
   int HID;
   float E,E1,E2,E3,Z,A,R,alpha1,alpha2;
   part_info_t *pinfo;
   float E_total_calorimeter=0.0;
   float E_total_inner_calorimeter=0.0;
   float E_total_outer_calorimeter=0.0;
   int NID;
   int two_parts;
   float dX,dY;
   int xbits,ybits,nxbits,nybits;
   float x1,y1,x2,y2;
   char str[256];
   static time_t last_time=0L;
   static int goods=0,trigs=0;
   float Efraction_missed;
   float P,px,py,pz,phi,theta;
   float M;
   static int ntuple_message=0;
   float a,b;
   int dx1,dy1,dx5hi,dx5lo,dy5hi,dy5lo;
	int Nphotons_detected=0,N1GeVphotons_detected=0;
	float N1GeVcharged_detected=0;
	float Rphotons[max_part_infos],R1GeVphotons[max_part_infos];
	float Ephoton_MaxE=0.0,Rphoton_MaxE=0.0;

   /****************************************************************/
   /* X-Y position of pairs (photons) at front face of calorimeter */
   /****************************************************************/
#if 0
   if(pair_e_X!=-10000.0)hf2(5000,pair_e_X/100.0,pair_e_Y/100.0,1.0);
   if(pair_p_X!=-10000.0)hf2(5000,pair_p_X/100.0,pair_p_Y/100.0,1.0);
   
   if(phot_1_X!=-10000.0)hf2(5001,phot_1_X/100.0,phot_1_Y/100.0,1.0);
   if(phot_2_X!=-10000.0)hf2(5001,phot_2_X/100.0,phot_2_Y/100.0,1.0);
   if(phot_1_X!=-10000.0 && phot_2_X!=-10000.0){
      a=newdet_.pi0d[2]-thargt_.thrpos[2];
      alpha1=atan(sqrt(pow(phot_1_X,2.0)+pow(phot_1_Y,2.0))/a);
      alpha2=atan(sqrt(pow(phot_2_X,2.0)+pow(phot_2_Y,2.0))/a);
      hf2(5002,alpha2/DEG2RAD,alpha1/DEG2RAD,1.0);
   }
#endif

   /*----------- fill subsets data structures ------------*/
   ProcessSubsets(SHWDET,TSHWDET);   
   
   /* Total energy in calorimeter */
   E_total_calorimeter      =FindSubset("ALL"  )->E;
   E_total_outer_calorimeter=FindSubset("OUTER")->E;
   E_total_inner_calorimeter=FindSubset("INNER")->E;
   
   hf1(1 ,re->Ephoton              ,1.0);
   hf1(2 ,E_total_calorimeter      ,1.0);
   if(GEOMETRY_TYPE==0){
   	hf1(3 ,E_total_outer_calorimeter,1.0);
   	hf1(4 ,E_total_inner_calorimeter,1.0);

	   hf1(1200,(float)FindSubset("OUTER")->HITS,1.0);
	   hf1(1201,(float)FindSubset("INNER")->HITS,1.0);

   	if(FindSubset("V9" )->E > trig_thresh)hf1(1006,1.0 ,1.0);
   	if(FindSubset("V24")->E > trig_thresh)hf1(1006,2.0 ,1.0);
	   if(FindSubset("V25")->E > trig_thresh)hf1(1006,3.0 ,1.0);
	   if(FindSubset("V26")->E > trig_thresh)hf1(1006,4.0 ,1.0);
	   if(FindSubset("V27")->E > trig_thresh)hf1(1006,5.0 ,1.0);
	   if(FindSubset("V10")->E > trig_thresh)hf1(1006,6.0 ,1.0);

	   /* paircounters */
	   if(SHWDET[2001]>0.0){hf1(2001,SHWDET[2001],1.0);}
	   if(SHWDET[2002]>0.0){hf1(2002,SHWDET[2002],1.0);}
	   if(SHWDET[2003]>0.0){hf1(2003,SHWDET[2003],1.0);}
	   if(SHWDET[2004]>0.0){hf1(2004,SHWDET[2004],1.0);}

	   /*---------------------- Tracks histogram -------------------------*/
	   HID=4000;
	   for(i=0;i<Npart_infos;i++){
	      if(pinfo[i].E<0.5)continue;
	      if(pinfo[i].type>ptype_gamma)continue;
	      px= pinfo[i].PX;
	      py= pinfo[i].PY;
	      pz= pinfo[i].PZ;
	      x1= pinfo[i].Z;
	      y1= pinfo[i].X;
	      
	      for(j=1;j<950;j++){
	         hf2_(&HID,&x1,&y1,&fone);
	         x1-=pz;
	         y1-=px;
	      }
	   }

   /*-----------------------------------------------------------------------*/

	   if(Npart_infos==2){
	      E=pinfo[0].E + pinfo[1].E;
	      R=sqrt(pinfo[0].X*pinfo[0].X + pinfo[0].Y*pinfo[0].Y +pinfo[0].Z*pinfo[0].Z);
	      if(R==0.0)R=-1.0E10;
	      px=pinfo[0].p*pinfo[0].X/R;
	      py=pinfo[0].p*pinfo[0].Y/R;
	      pz=pinfo[0].p*pinfo[0].Z/R;

	      R=sqrt(pinfo[1].X*pinfo[1].X + pinfo[1].Y*pinfo[1].Y +pinfo[1].Z*pinfo[1].Z);
	      if(R==0.0)R=-1.0E10;
	      px+=pinfo[1].p*pinfo[1].X/R;
	      py+=pinfo[1].p*pinfo[1].Y/R;
	      pz+=pinfo[1].p*pinfo[1].Z/R;
	      
	      P=sqrt(px*px + py*py + pz*pz);
	      M=sqrt(E*E-P*P);
	      HID=3000;hf1_(&HID,&M,&fone);
	      
	      /* take dot product and divide by magnitudes to get opening angle */
	      A=pinfo[0].X*pinfo[1].X + pinfo[0].Y*pinfo[1].Y +pinfo[0].Z*pinfo[1].Z;
	      R=sqrt(pinfo[0].X*pinfo[0].X + pinfo[0].Y*pinfo[0].Y +pinfo[0].Z*pinfo[0].Z);
	      if(R==0.0)R=-1.0E10;
	      A/=R;
	      R=sqrt(pinfo[1].X*pinfo[1].X + pinfo[1].Y*pinfo[1].Y +pinfo[1].Z*pinfo[1].Z);
	      if(R==0.0)R=-1.0E10;
	      A/=R;
	      theta=acos(A)*180.0/3.14159;
	      HID=3002;hf1_(&HID,&theta,&fone);
	   }
	}else{ /* GEOMETRY_TYPE =1 */
		hf1(20 ,E_total_calorimeter - FindSubset("HOLE3")->E,1.0);
		hf1(21 ,E_total_calorimeter - FindSubset("HOLE5")->E,1.0);
		hf1(22 ,E_total_calorimeter - FindSubset("HOLE7")->E,1.0);

	   hf1(1200,(float)FindSubset("ALL")->HITS,1.0);

		/* count number of photons hitting calorimeter */
		/* (remember distance from beam)               */
		for(i=0;i<Npart_infos;i++){
			/*if(fabs(re->part_info[i].Z-newdet_.pi0d[2])>1.0)continue;*/
			if(fabs(re->part_info[i].Z-500.0)>1.0)continue;
	      if(re->part_info[i].type==ptype_gamma){
	      	R=sqrt(pow(re->part_info[i].X,2.0)+pow(re->part_info[i].Y,2.0));
	      	Rphotons[Nphotons_detected++]=R;
	      	if(re->part_info[i].E>=1.0)R1GeVphotons[N1GeVphotons_detected++]=R;

	      	if(re->part_info[i].E>Ephoton_MaxE){
	      		Ephoton_MaxE=re->part_info[i].E;
	      		Rphoton_MaxE=R;
	      	}
	      }
	      if(chargeof(re->part_info[i].type))
	      	if(re->part_info[i].E>=0.010)N1GeVcharged_detected++;
		}
		hf1(2000+(100*re->type)+re->decay_mech,(float)Nphotons_detected,1.0);
		hf1(3000+(100*re->type)+re->decay_mech,E_total_calorimeter,1.0);
		hf2(4200,Rphoton_MaxE,Ephoton_MaxE,1.0);
		hf2(4300,(float)N1GeVphotons_detected,(float)N1GeVcharged_detected,1.0);
		if(E_total_calorimeter>=1.0 && N1GeVcharged_detected)
			hf1(4400,2.0,1.0);
		else
			hf1(4400,1.0,1.0);

		if(re->type==5)
			hf1(2000+re->decay_mech,(float)N1GeVphotons_detected,1.0);

		/* Sort photon distances in decreasing order */
		do{
			for(i=1;i<Nphotons_detected;i++){
				if(Rphotons[i]>Rphotons[i-1]){
					R=Rphotons[i];
					Rphotons[i]=Rphotons[i-1];
					Rphotons[i-1]=R;
					break;
				}
			}
		}while(i<Nphotons_detected);
		do{
			for(i=1;i<N1GeVphotons_detected;i++){
				if(R1GeVphotons[i]>R1GeVphotons[i-1]){
					R=R1GeVphotons[i];
					R1GeVphotons[i]=R1GeVphotons[i-1];
					R1GeVphotons[i-1]=R;
					break;
				}
			}
		}while(i<N1GeVphotons_detected);
		
		if(Nphotons_detected>=1){
			if(re->type==5 && re->decay_mech==0)hf1(4000,Rphotons[0],1.0);
			if(re->type==5 && re->decay_mech==1)hf1(4002,Rphotons[0],1.0);
			if(re->type==5 && re->decay_mech==2)hf1(4004,Rphotons[0],1.0);
		}
		if(Nphotons_detected>=2){
			if(re->type==5 && re->decay_mech==0)hf1(4001,Rphotons[1],1.0);
			if(re->type==5 && re->decay_mech==1)hf1(4003,Rphotons[1],1.0);
			if(re->type==5 && re->decay_mech==2)hf1(4005,Rphotons[1],1.0);
		}
		if(N1GeVphotons_detected>=1){
			if(re->type==5 && re->decay_mech==0)hf1(4100,R1GeVphotons[0],1.0);
			if(re->type==5 && re->decay_mech==1)hf1(4102,R1GeVphotons[0],1.0);
			if(re->type==5 && re->decay_mech==2)hf1(4104,R1GeVphotons[0],1.0);
		}
		if(N1GeVphotons_detected>=2){
			if(re->type==5 && re->decay_mech==0)hf1(4101,R1GeVphotons[1],1.0);
			if(re->type==5 && re->decay_mech==1)hf1(4103,R1GeVphotons[1],1.0);
			if(re->type==5 && re->decay_mech==2)hf1(4105,R1GeVphotons[1],1.0);
		}

   }
   
   px=re->initial_4vect.x;
   py=re->initial_4vect.y;
   pz=re->initial_4vect.z;

   P=sqrt((px*px) + (py*py));
   find_theta_phi(re->initial_4vect, &theta, &phi);
   theta*=DEG2RAD*1000.0;
   hf1(5,phi,1.0);
   
   hf1(6,theta,1.0);

   hf1(7,SHWDET[2040],1.0);

   hf2(8,re->subtype,theta,1.0);
   hf2(9,re->decay_mech,theta,1.0);
   
   hf1(1000,(float)re->type,1.0);

	
   
   pinfo=re->part_info;
   for(i=0;i<Npart_infos;i++){
      hf2(1204,pinfo[i].X,pinfo[i].Y,1.0);
      hf2(1205,pinfo[i].X,pinfo[i].Y,pinfo[i].E);
      hf1(1206,pinfo[i].X,1.0);
      hf1(1207,pinfo[i].Y,1.0);
      hf2(1208,pinfo[i].X,pinfo[i].Y,SHWDET[2010]);

		if(fabs(pinfo[i].Z-700.0)>1.0)continue;

		R=sqrt(pow(pinfo[i].X,2.0)+pow(pinfo[i].Y,2.0));
		hf2(3,R,pinfo[i].E,1.0);
	
		if(pinfo[i].E>0.010){
			hf1(1300,pinfo[i].X,1.0);
			hf1(1310,pinfo[i].Y,1.0);
		}
		if(pinfo[i].E>0.100){
			hf1(1301,pinfo[i].X,1.0);
			hf1(1311,pinfo[i].Y,1.0);
		}
		if(pinfo[i].E>1.000){
			hf1(1302,pinfo[i].X,1.0);
			hf1(1312,pinfo[i].Y,1.0);
		}
		if(pinfo[i].E>2.000){
			hf1(1303,pinfo[i].X,1.0);
			hf1(1313,pinfo[i].Y,1.0);
		}
		if(pinfo[i].E>5.000){
			hf1(1304,pinfo[i].X,1.0);
			hf1(1314,pinfo[i].Y,1.0);
		}
		if(pinfo[i].E>7.000){
			hf1(1305,pinfo[i].X,1.0);
			hf1(1315,pinfo[i].Y,1.0);
		}
		if(pinfo[i].E>8.000){
			hf1(1306,pinfo[i].X,1.0);
			hf1(1316,pinfo[i].Y,1.0);
		}
   }



   /**************************************************************/
   /* Fill in trigger info now in case we're not simulating pi0s */
   /**************************************************************/
   bzero(&trig_rate,sizeof(trig_rate_t));

   /**********************************************************/
   /* Store info about the two gammas from pion decay        */
   /* along with info about what the trigger would have done */
   /**********************************************************/
   pinfo=re->part_info;
   Npart_infos=re->Npart_infos;
   if(Npart_infos>0){ 

#if 0
      NID=nt3;
      two_parts=Npart_infos>1;
      
      trig_rate.X1=pinfo[0].X;
      trig_rate.Y1=pinfo[0].Y;
      trig_rate.Z1=pinfo[0].Z;

      trig_rate.X2=two_parts ? pinfo[1].X:0.0;
      trig_rate.Y2=two_parts ? pinfo[1].Y:0.0;
      trig_rate.Z2=two_parts ? pinfo[1].Z:0.0;
      
      trig_rate.pid1=(float)pinfo[0].type;
      trig_rate.pid2=two_parts ? (float)pinfo[1].type:0.0;

      trig_rate.E1=(float)pinfo[0].E;
      trig_rate.E2=two_parts ? (float)pinfo[1].E:0.0;

      trig_rate.Ephoton=re->Ephoton;
      trig_rate.Edep=FindSubset("ALL")->E;
      
      /* This is now the ratio of the undetected energy to the */
      /* energy of the weaker photon. This should be >=1 when  */
      /* one of the photons is missed.                         */
      Efraction_missed=(trig_rate.E1+trig_rate.E2)-trig_rate.Edep;
      Efraction_missed/=
         trig_rate.E1>trig_rate.E2 ? trig_rate.E2:trig_rate.E1;
      
      if(Npart_infos > 1){
         dX=trig_rate.X1-trig_rate.X2;
         dY=trig_rate.Y1-trig_rate.Y2;
         R=sqrt((dX*dX) + (dY*dY));
         trig_rate.dist=R;
      }else{
         trig_rate.dist=0.0;
      }
      

      trig_rate.good  =good_event(re);      
      trig_rate.trig  =trigger(trig_thresh,&xbits,&ybits);
      HID=1002;a=(float)xbits;hf1_(&HID,&a,&fone);
      HID=1003;a=(float)ybits;hf1_(&HID,&a,&fone);
      trig_rate.xbits =xbits;
      trig_rate.ybits =ybits;
      dx1=trig1_discriminators_x;
      dy1=trig1_discriminators_y;
      trig_rate.trig2 =trigger2(trig_thresh,&xbits,&ybits);
      HID=1004;a=(float)xbits;hf1_(&HID,&a,&fone);
      HID=1005;a=(float)ybits;hf1_(&HID,&a,&fone);
      trig_rate.trig3 =trigger3(trig_thresh);
      trig_rate.trig4 =trigger4(trig_thresh);
      trig_rate.trig5 =trigger5(trig_thresh,NULL,NULL);
      dx5hi=trig5_discriminators_xhi;
      dy5hi=trig5_discriminators_yhi;
      dx5lo=trig5_discriminators_xlo;
      dy5lo=trig5_discriminators_ylo;

      for(i=0;i<10;i++)if((dx1>>i)&0x1)hf1(1007,(float)i,1.0);
      for(i=0;i<10;i++)if((dy1>>i)&0x1)hf1(1008,(float)i,1.0);
      for(i=0;i<10;i++)if((dx5lo>>i)&0x1)hf1(1009,(float)i,1.0);
      for(i=0;i<10;i++)if((dy5lo>>i)&0x1)hf1(1010,(float)i,1.0);
      for(i=0;i<10;i++)if((dx5hi>>i)&0x1)hf1(1011,(float)i,1.0);
      for(i=0;i<10;i++)if((dy5hi>>i)&0x1)hf1(1012,(float)i,1.0);

      /*****************************************/
      /* Some info for trigger efficiencies.   */
      /*                                       */
      /* bin at 0: "good" event                */
      /* bin at 1: trigger 1                   */
      /* bin at 2: trigger 2                   */
      /* bin at 3: trigger 3                   */
      /* bin at 4: trigger 4                   */
      /*                                       */
      /* bins 1-4 are repeated in bins 11-14   */
      /* but with a cut on "good" being        */
      /* true.                                 */
      /*****************************************/
   
      if(trig_rate.good )hf1(1001,0.0,1.0);
      if(trig_rate.trig )hf1(1001,1.0,1.0);
      if(trig_rate.trig2)hf1(1001,2.0,1.0);
      if(trig_rate.trig3)hf1(1001,3.0,1.0);
      if(trig_rate.trig4)hf1(1001,4.0,1.0);
      if(trig_rate.trig5)hf1(1001,5.0,1.0);
      if(trig_rate.good>0){
         if(trig_rate.trig )hf1(1001,11.0,1.0);
         if(trig_rate.trig2)hf1(1001,12.0,1.0);
         if(trig_rate.trig3)hf1(1001,13.0,1.0);
         if(trig_rate.trig4)hf1(1001,14.0,1.0);
         if(trig_rate.trig5)hf1(1001,15.0,1.0);
      }
      
      if(trig_rate.good>0){
         goods++;
         if(trig_rate.trig>0)trigs++;
         
         /* fill ntuple */
         if(++NTPULE_EVENTS_WRITTEN <= 1000){
            hfn_(&NID,&trig_rate);    /* trig_rate ntuple */
         }else if(!ntuple_message){
            /*printf("\nNtuple full! only histogram filling from this point on.\n");*/
            ntuple_message=1;
         }
      }
      
      /*---------------------- print more debug info --------------------------*/
      if(debug>0){
         printf("%d: good:%1.0f  trig:%1.0f  xbits:%d  ybits:%d\n"
            ,IEVENT,trig_rate.good,trig_rate.trig,xbits,ybits);
         if(debug>1){
            if((trig_rate.trig==0) && (trig_rate.good>0))
               printf("%d:bad hit: ybits=%d xbits=%d E1=%3.1f E2=%3.1f Edep=%3.1f\n"
                  ,IEVENT,ybits,xbits,trig_rate.E1,trig_rate.E2,trig_rate.Edep);
               printf("%d: x1:%3.2f y1:%3.2f z1:%3.2f x2:%3.2f y2:%3.2f z2:%3.2f\n"
                  ,IEVENT,trig_rate.X1,trig_rate.Y1,trig_rate.Z1
                  ,trig_rate.X2,trig_rate.Y2,trig_rate.Z2);
         }
      }
      /*-----------------------------------------------------------------------*/
#endif
      
      
      /*------------------------- update screen -----------------------*/
      if(flags[update_goods]){
         if(time(NULL)-last_time>2L){
            last_time=time(NULL);
            printf("trigs:%d  goods:%3d ",trigs,goods);
         }
      }
   }


   
}

//=====================================
// find theta and phi from 3 vector
//=====================================
void find_theta_phi(vect4 v, float *theta,float *phi_ret)
{
   float phi=0.0,r;
   int sector;

   /* phi */
   r=sqrt((v.x*v.x) + (v.y*v.y));
   if(r!=0.0)phi = (180.0/PI)*acos(v.x/r);
   if(v.y<0.0)phi = 360.0-phi;
   while(phi<0.0)phi+=360.0;
   while(phi>360.0)phi-=360.0;
   *phi_ret=phi;

   /* theta */
   r=sqrt((v.x*v.x) + (v.y*v.y) + (v.z*v.z));
   if(r!=0.0)*theta = (180.0/PI)*acos(v.z/r);
   while(*theta<0.0)*theta+=180.0;
   if(v.x==0.0 && v.y==0.0)*theta=0.0;


}





