


#include "psim.h"


extern float max_energy,pos_of_Emax[3];


/************************************************/
/* This is called at the begining of each event */
/************************************************/

void gukine_(void)
{
   int i;
   static long last_time=0L;
   int *ISWIT = gcflag_.iswit;
   float *SHWDET  = cheren_.shwdet;
   float *TSHWDET = cheren_.tshwdet;
   static unsigned int cntr=1;
   float U0,V0,x_draw=0.0,y_draw=0.0,z_draw=0.0,AXSIZ=50.;
   
   if(flags[verbose])printf("Event starting...\n");
   
   /* reset flags */
   for(i=0;i<NUM_TRACKFLAGS;i++)track_flags[i]=0;
   
   /* reset detectors */
   for(i=0;i<max_detectors;i++){
      (*SHWDET++)=0.0;
      (*TSHWDET++)=0.0;
   }
   nascom_.edttsw=0.0;
   
   /* reset subsets */
   for(i=0;i<nsets;i++){
      sets[i]->HITS = 0  ;
      sets[i]->E    = 0.0;
      sets[i]->T    = 0.0;
   }
   
   /* reset part_info */
   Npart_infos=0;
   bzero(part_info, sizeof(part_info_t)*max_part_infos);
   
   /* Optionally draw track every ISWIT(1) seconds */
   if(flags[draw_tracks]){
      if(ISWIT[0]==1)track_flags[draw_track]=1;
      if(ISWIT[0]>1){
         if(time(NULL)-last_time>ISWIT[0]){
            last_time=time(NULL);
            track_flags[draw_track]=1;
            printf("Drawing new track!!\n");
         }
      }
      
      /* redraw the detector every so often */
      if(track_flags[draw_track]){
         if(((cntr++)%20000) == 0){
            gdraw_("HALB",&vtheta,&vphi,&vpsi,&vu,&vv,&vsu,&vsv,strlen("HALB"));
            U0=1.0;V0=5.0;
            gdscal_(&U0,&V0);
            gdaxis_(&x_draw,&y_draw,&z_draw,&AXSIZ);
            ixupdwi_(&zero); /* update window */
         }
      }
   }
   
   
   /* position of maximum energy particle */
   max_energy=0.0;
   pos_of_Emax[0]=0.0;
   pos_of_Emax[1]=0.0;
   pos_of_Emax[2]=0.0;

   /* X-Y position of pairs (photons) at front face of calorimeter */
   pair_e_X=pair_e_Y=-10000.0;
   pair_p_X=pair_p_Y=-10000.0;
   phot_1_X=phot_1_Y=-10000.0;
   phot_2_X=phot_2_Y=-10000.0;

   /* Generate event */
   generate_event();
   
}












