


#include "psim.h"


void guout_(void)
{
   int i,j;
   subset *s;
   static long start_time=0L,last_time=0L,begin_run_time=0L;
   static float last_ievent=0.0;
   float delta_events,delta_time;
   int something_hit=0;
   raw_event_t *re;
   part_info_t tmp_part_info;
   
   if(flags[verbose])printf("Event ending...");fflush(stdout);
   
   if(flags[draw_tracks])ixupdwi_(&zero); /* update window */

   /* update screen info */
   if(start_time==0L)start_time=last_time=begin_run_time=time(NULL);
   if(time(NULL)-last_time>=2L){      
      delta_events=(float)gcflag_.ievent-last_ievent;
      delta_time=(float)(time(NULL)-start_time);
      if(!flags[batch_mode]){
      	printf("\r  %dk / %3.1fM evts (%d%c good)   %3.3f evts/sec   "
         	,IEVENT/1000
	         ,(float)NEVENT/1000000.0
	         ,N_GOOD_EVENT>1000 ? N_GOOD_EVENT/1000:N_GOOD_EVENT
	         ,N_GOOD_EVENT>1000 ? 'k':' '
	         ,delta_events/delta_time);
	   }
      
      fflush(stdout);
      last_time=time(NULL);

		/* want the rate to be fairly accurate despit pauses etc. */
		if(last_time-start_time>20.0){
			start_time=last_time;
			last_ievent=(float)gcflag_.ievent;
		}
      
   
      /* If running in batch mode, decide if we should quit */
      if(run_time>0.0)
         if((double)(time(NULL)-begin_run_time)>=3600.0*run_time)flags[quit]=1;
   }

   /* look for quit condition */
   if(flags[quit])IEORUN=1;
   if(IEVENT>=NEVENT)IEORUN=1;


   /* re-arrange part_info structures in order of decsending energy */
   do{
      for(i=1;i<Npart_infos;i++){
         if(part_info[i].E>part_info[i-1].E){
         
            tmp_part_info  = part_info[i-1];
            part_info[i-1] = part_info[ i ];
            part_info[ i ] = tmp_part_info;
            break;
         }
      }
   }while(i<Npart_infos);


   /* fill raw event data structure and write to file if neccesary */
   re=write_binary_event();

   /*-------------- check if event is worth saving ---------------*/
   if(re->Edeposited<EVENT_WRITE_TRHESHOLD)return;
   /*-------------------------------------------------------------*/

   N_GOOD_EVENT++;

	/* write event to file */
   if(flags[output_gzip])gzwrite(gzfile,re,sizeof(raw_event_t));
 
   /* fill histograms */
   if(flags[fill_histograms])fill_histos(re);



   if(flags[verbose])printf("done\n");fflush(stdout);
}












