C
      SUBROUTINE PR_KIN
C
C     This program calculates the all kinematic variabls for Real Prim. Exp.
C     It requirs the energy of particle (electrons or proton) in GeV, TETA,  ?
C      DELTET, FI, DELFI in LAB.  frame  in Degrees                          ?
C              IN DOUBLE PRECISION                                           ?
C
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
C
      COMMON/KINEM1/EINI,TPI0,FIPI0G,EPI0SP,TRECSP,TKINRM
      COMMON/KINEM2/PPREL(3)
      COMMON/KINEM3/EPI0LF,PPI0LF(3),EG1LF,PG1LF(3),EG2LF,PG2LF(3)
C
      DIMENSION RNDM(2)
C
C      DOUBLE PRECISION EMMU,PMASS,AVO
C
      DOUBLE PRECISION C1,A1,A2,A3
      DOUBLE PRECISION AMASS,PI0MAS,TPI0DP,TRECDP,TKINRC,ENERRC
      DOUBLE PRECISION PPI0DP,EPI0DP
      DOUBLE PRECISION EGBEDP,DISCRI,U,ARECOI,TCONS1
C
      DOUBLE PRECISION PI,TWOPI,PIBY2,DEGRAD,RADDEG,EMASS
C
      PARAMETER (PI=3.14159265358979324)
      PARAMETER (TWOPI=6.28318530717958648)
      PARAMETER (PIBY2=1.57079632679489662)
      PARAMETER (DEGRAD=0.0174532925199432958)
      PARAMETER (RADDEG=57.2957795130823209)
      PARAMETER (EMASS=0.0005109990615)
C
      PARAMETER (PI0MAS=0.1349764)
C
CC      PARAMETER (EMMU=0.105658387)
CC      PARAMETER (PMASS=0.9382723128)
CC      PARAMETER (AVO=0.60221367)
C
      U = 0.931502D0
      ARECOI = 207.976627D0                !  for Pb^208
C      ARECOI = 4.002603D0                  ! for  He^4
C
      AMASS = ARECOI*U
C 
C  PKINE(1) => is the initial Tagged Photon beam energy in GeV  = EINI
C  PKINE(2) => is +/- DeltaE/E in % for Initial Electron Beam
C N/A  PKINE(3) => is TETA angle of scattered electron in Lab frame(deg.)
C N/A  PKINE(4) => is DELTET aperture ( +/- DElTET is the full angle)(deg.)
C N/A  PKINE(5) => is FI angle of the Scattered Electrons           (deg.)
C N/A  PKINE(6) => is DELDI  aperture (+/-  DELFI is the FULL angle) (deg.)
C N/A  PKINE(7) => is the Epr energy of the Scattered Electron,
C N/A  PKINE(8) => is the +/- DelEpr/Epr in %  
C  PKINE(9) => is the PI0 meson Polar angle with Tagged Photon (deg.)
C  PKINE(10) => is the PI0 meson Azimutal angle --///-----
C  First one here is IKINE => the type of the particle ( be careful )
C  
C
      EINI  = PKINE(1)
C
      EGBEDP = DBLE(PKINE(1))
C
      TPI0DP = DBLE(PKINE(9))                  ! in degrees
C
      C1=(2.D0*EGBEDP*AMASS+PI0MAS*PI0MAS)/2.D0
      TCONS1=(EGBEDP+AMASS)**2
      A1=EGBEDP*EGBEDP*(DCOS(DEGRAD*TPI0DP))**2-TCONS1
      A2=2.D0*EGBEDP*C1*DCOS(DEGRAD*TPI0DP)
      A3=C1*C1-PI0MAS*PI0MAS*(EGBEDP+AMASS)**2
C
      DISCRI = (A2*A2-4.D0*A1*A3)
      IF(DISCRI.LE.0.D0)THEN
      WRITE(6,*)'Discriminator under SQRT is LT than 0.'
C
      ELSE
         PPI0DP=(-A2-DSQRT(DISCRI))/(2.D0*A1)
C
         EPI0DP=DSQRT(PPI0DP*PPI0DP+PI0MAS*PI0MAS)
         TKINRC=EGBEDP-EPI0DP
         ENERRC=AMASS+TKINRC
         PMOMRC=DSQRT(ENERRC*ENERRC-AMASS*AMASS)
         TRECDP=RADDEG*(DASIN((PPI0DP*DSIN(DEGRAD*TPI0DP))/PMOMRC))
C
         TPI0 = PKINE(9)                ! in degrees
C
CA         FIPI0G= PKINE(10)               ! in degrees
C
C            now we are sampling the fipi0 in 0-360 degrees
C
      CALL GRNDM(RNDM,2)
C
      FIPI0R = 2.*3.14159265*RNDM(2)        ! in radians
      FIPI0G = 57.2957795*FIPI0R
C
         EPI0LF=SNGL(EPI0DP)
         EPI0SP=EPI0LF
         PPI0 = SNGL(PPI0DP)
         TRECSP=SNGL(TRECDP)
         TKINRM=1000.*SNGL(TKINRC)          ! T kin of Rec. Nuc. in MeV
C
         PPI0LF(1)=PPI0*SIN(DEGRAD*TPI0)*COS(FIPI0R)
         PPI0LF(2)=PPI0*SIN(DEGRAD*TPI0)*SIN(FIPI0R)
         PPI0LF(3)=PPI0*COS(DEGRAD*TPI0)
C
         ENDIF
C
C
      CALL HF1(1,EINI,1.)
      CALL HF1(2,TPI0,1.)
      CALL HF1(3,FIPI0G,1.)
      CALL HF1(4,EPI0LF,1.)
      CALL HF1(5,TRECSP,1.)
      CALL HF1(6,TKINRM,1.)
C
C
         CALL PI0_CM
C
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C   General formula for translation (0,1) to (a,b) is
C       c=RNDM*(b-a)+a    where RNDM from (0,1) and c will be in (a,b)
C
C      CALL GRNDM(RNDM,2)
C
C      A     = COS(DEGRAD*(PKINE(3)-PKINE(4)))
C      B     = COS(DEGRAD*(PKINE(3)+PKINE(4)))
C      C     = RNDM(1)*(B-A)+A
C
C      TELRLF = ACOS(C)
C      TELGLF = RADDEG*TELRLF
C
C      CALL HF1(1,TELGLF,1.)
C
C      FELGLF = PKINE(5)+PKINE(6)*(2.*RNDM(2)-1.)
C
C      CALL HF1(2,FELGLF,1.)
C
C      FELRLF = DEGRAD*FELGLF
C
C
      RETURN
      END















